<?php
/**
 * InlineResponse20067ContentItemsAllOf1
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20067ContentItemsAllOf1 Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20067ContentItemsAllOf1 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_67_contentItems_allOf_1';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'accountingTypeId' => 'int',
        'booked' => 'bool',
        'clearanceStatus' => 'string',
        'companyId' => 'int',
        'contractId' => 'int',
        'createdEmployeeId' => 'int',
        'departmentId' => 'int',
        'durationApproach' => 'int',
        'durationDeparture' => 'int',
        'startBreak' => 'int',
        'durationBreak' => 'int',
        'erpNumber' => 'string',
        'extern' => 'bool',
        'externalTicketId' => 'string',
        'hourlyRate' => 'double',
        'installationFee' => 'bool',
        'installationFeeAmount' => 'double',
        'installationFeeTypeId' => 'int',
        'internal' => 'bool',
        'outlook' => 'bool',
        'supportIconType' => 'string',
        'textIntern' => 'string',
        'voucherId' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'accountingTypeId' => null,
        'booked' => null,
        'clearanceStatus' => null,
        'companyId' => null,
        'contractId' => null,
        'createdEmployeeId' => null,
        'departmentId' => null,
        'durationApproach' => null,
        'durationDeparture' => null,
        'startBreak' => 'tiemstamp',
        'durationBreak' => null,
        'erpNumber' => null,
        'extern' => null,
        'externalTicketId' => null,
        'hourlyRate' => 'double',
        'installationFee' => null,
        'installationFeeAmount' => 'double',
        'installationFeeTypeId' => null,
        'internal' => null,
        'outlook' => null,
        'supportIconType' => null,
        'textIntern' => null,
        'voucherId' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'accountingTypeId' => 'accountingTypeId',
        'booked' => 'booked',
        'clearanceStatus' => 'clearanceStatus',
        'companyId' => 'companyId',
        'contractId' => 'contractId',
        'createdEmployeeId' => 'createdEmployeeId',
        'departmentId' => 'departmentId',
        'durationApproach' => 'durationApproach',
        'durationDeparture' => 'durationDeparture',
        'startBreak' => 'startBreak',
        'durationBreak' => 'durationBreak',
        'erpNumber' => 'erpNumber',
        'extern' => 'extern',
        'externalTicketId' => 'externalTicketId',
        'hourlyRate' => 'hourlyRate',
        'installationFee' => 'installationFee',
        'installationFeeAmount' => 'installationFeeAmount',
        'installationFeeTypeId' => 'installationFeeTypeId',
        'internal' => 'internal',
        'outlook' => 'outlook',
        'supportIconType' => 'supportIconType',
        'textIntern' => 'textIntern',
        'voucherId' => 'voucherId'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'accountingTypeId' => 'setAccountingTypeId',
        'booked' => 'setBooked',
        'clearanceStatus' => 'setClearanceStatus',
        'companyId' => 'setCompanyId',
        'contractId' => 'setContractId',
        'createdEmployeeId' => 'setCreatedEmployeeId',
        'departmentId' => 'setDepartmentId',
        'durationApproach' => 'setDurationApproach',
        'durationDeparture' => 'setDurationDeparture',
        'startBreak' => 'setStartBreak',
        'durationBreak' => 'setDurationBreak',
        'erpNumber' => 'setErpNumber',
        'extern' => 'setExtern',
        'externalTicketId' => 'setExternalTicketId',
        'hourlyRate' => 'setHourlyRate',
        'installationFee' => 'setInstallationFee',
        'installationFeeAmount' => 'setInstallationFeeAmount',
        'installationFeeTypeId' => 'setInstallationFeeTypeId',
        'internal' => 'setInternal',
        'outlook' => 'setOutlook',
        'supportIconType' => 'setSupportIconType',
        'textIntern' => 'setTextIntern',
        'voucherId' => 'setVoucherId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'accountingTypeId' => 'getAccountingTypeId',
        'booked' => 'getBooked',
        'clearanceStatus' => 'getClearanceStatus',
        'companyId' => 'getCompanyId',
        'contractId' => 'getContractId',
        'createdEmployeeId' => 'getCreatedEmployeeId',
        'departmentId' => 'getDepartmentId',
        'durationApproach' => 'getDurationApproach',
        'durationDeparture' => 'getDurationDeparture',
        'startBreak' => 'getStartBreak',
        'durationBreak' => 'getDurationBreak',
        'erpNumber' => 'getErpNumber',
        'extern' => 'getExtern',
        'externalTicketId' => 'getExternalTicketId',
        'hourlyRate' => 'getHourlyRate',
        'installationFee' => 'getInstallationFee',
        'installationFeeAmount' => 'getInstallationFeeAmount',
        'installationFeeTypeId' => 'getInstallationFeeTypeId',
        'internal' => 'getInternal',
        'outlook' => 'getOutlook',
        'supportIconType' => 'getSupportIconType',
        'textIntern' => 'getTextIntern',
        'voucherId' => 'getVoucherId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const CLEARANCE_STATUS_NONE = 'NONE';
    public const CLEARANCE_STATUS_CLEARED = 'CLEARED';
    public const SUPPORT_ICON_TYPE_STANDARD = 'STANDARD';
    public const SUPPORT_ICON_TYPE_REMOTE = 'REMOTE';
    public const SUPPORT_ICON_TYPE_NOT_CHARGED = 'NOT_CHARGED';
    public const SUPPORT_ICON_TYPE_ERP = 'ERP';
    public const SUPPORT_ICON_TYPE_INSTALLATION_FEE = 'INSTALLATION_FEE';
    public const SUPPORT_ICON_TYPE_FULLSERVICE = 'FULLSERVICE';
    public const SUPPORT_ICON_TYPE_CONTRACT = 'CONTRACT';
    public const SUPPORT_ICON_TYPE_PREPAID = 'PREPAID';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getClearanceStatusAllowableValues()
    {
        return [
            self::CLEARANCE_STATUS_NONE,
            self::CLEARANCE_STATUS_CLEARED,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getSupportIconTypeAllowableValues()
    {
        return [
            self::SUPPORT_ICON_TYPE_STANDARD,
            self::SUPPORT_ICON_TYPE_REMOTE,
            self::SUPPORT_ICON_TYPE_NOT_CHARGED,
            self::SUPPORT_ICON_TYPE_ERP,
            self::SUPPORT_ICON_TYPE_INSTALLATION_FEE,
            self::SUPPORT_ICON_TYPE_FULLSERVICE,
            self::SUPPORT_ICON_TYPE_CONTRACT,
            self::SUPPORT_ICON_TYPE_PREPAID,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['accountingTypeId'] = $data['accountingTypeId'] ?? null;
        $this->container['booked'] = $data['booked'] ?? null;
        $this->container['clearanceStatus'] = $data['clearanceStatus'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['contractId'] = $data['contractId'] ?? null;
        $this->container['createdEmployeeId'] = $data['createdEmployeeId'] ?? null;
        $this->container['departmentId'] = $data['departmentId'] ?? null;
        $this->container['durationApproach'] = $data['durationApproach'] ?? null;
        $this->container['durationDeparture'] = $data['durationDeparture'] ?? null;
        $this->container['startBreak'] = $data['startBreak'] ?? null;
        $this->container['durationBreak'] = $data['durationBreak'] ?? null;
        $this->container['erpNumber'] = $data['erpNumber'] ?? null;
        $this->container['extern'] = $data['extern'] ?? null;
        $this->container['externalTicketId'] = $data['externalTicketId'] ?? null;
        $this->container['hourlyRate'] = $data['hourlyRate'] ?? null;
        $this->container['installationFee'] = $data['installationFee'] ?? null;
        $this->container['installationFeeAmount'] = $data['installationFeeAmount'] ?? null;
        $this->container['installationFeeTypeId'] = $data['installationFeeTypeId'] ?? null;
        $this->container['internal'] = $data['internal'] ?? null;
        $this->container['outlook'] = $data['outlook'] ?? null;
        $this->container['supportIconType'] = $data['supportIconType'] ?? null;
        $this->container['textIntern'] = $data['textIntern'] ?? null;
        $this->container['voucherId'] = $data['voucherId'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getClearanceStatusAllowableValues();
        if (!is_null($this->container['clearanceStatus']) && !in_array($this->container['clearanceStatus'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'clearanceStatus', must be one of '%s'",
                $this->container['clearanceStatus'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getSupportIconTypeAllowableValues();
        if (!is_null($this->container['supportIconType']) && !in_array($this->container['supportIconType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'supportIconType', must be one of '%s'",
                $this->container['supportIconType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets accountingTypeId
     *
     * @return int|null
     */
    public function getAccountingTypeId()
    {
        return $this->container['accountingTypeId'];
    }

    /**
     * Sets accountingTypeId
     *
     * @param int|null $accountingTypeId id of the accountingtype used for this support (i.e. \"Techniker\")
     *
     * @return self
     */
    public function setAccountingTypeId($accountingTypeId)
    {
        $this->container['accountingTypeId'] = $accountingTypeId;

        return $this;
    }

    /**
     * Gets booked
     *
     * @return bool|null
     */
    public function getBooked()
    {
        return $this->container['booked'];
    }

    /**
     * Sets booked
     *
     * @param bool|null $booked wether the support was already booked
     *
     * @return self
     */
    public function setBooked($booked)
    {
        $this->container['booked'] = $booked;

        return $this;
    }

    /**
     * Gets clearanceStatus
     *
     * @return string|null
     */
    public function getClearanceStatus()
    {
        return $this->container['clearanceStatus'];
    }

    /**
     * Sets clearanceStatus
     *
     * @param string|null $clearanceStatus determines if a support was already \"cleared\" for billing
     *
     * @return self
     */
    public function setClearanceStatus($clearanceStatus)
    {
        $allowedValues = $this->getClearanceStatusAllowableValues();
        if (!is_null($clearanceStatus) && !in_array($clearanceStatus, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'clearanceStatus', must be one of '%s'",
                    $clearanceStatus,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['clearanceStatus'] = $clearanceStatus;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company for this support
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets contractId
     *
     * @return int|null
     */
    public function getContractId()
    {
        return $this->container['contractId'];
    }

    /**
     * Sets contractId
     *
     * @param int|null $contractId id of the contract, used for this support
     *
     * @return self
     */
    public function setContractId($contractId)
    {
        $this->container['contractId'] = $contractId;

        return $this;
    }

    /**
     * Gets createdEmployeeId
     *
     * @return int|null
     */
    public function getCreatedEmployeeId()
    {
        return $this->container['createdEmployeeId'];
    }

    /**
     * Sets createdEmployeeId
     *
     * @param int|null $createdEmployeeId id of the employee who has created this support
     *
     * @return self
     */
    public function setCreatedEmployeeId($createdEmployeeId)
    {
        $this->container['createdEmployeeId'] = $createdEmployeeId;

        return $this;
    }

    /**
     * Gets departmentId
     *
     * @return int|null
     */
    public function getDepartmentId()
    {
        return $this->container['departmentId'];
    }

    /**
     * Sets departmentId
     *
     * @param int|null $departmentId if used, id of the department which is assigned to this support
     *
     * @return self
     */
    public function setDepartmentId($departmentId)
    {
        $this->container['departmentId'] = $departmentId;

        return $this;
    }

    /**
     * Gets durationApproach
     *
     * @return int|null
     */
    public function getDurationApproach()
    {
        return $this->container['durationApproach'];
    }

    /**
     * Sets durationApproach
     *
     * @param int|null $durationApproach duration (in minutes) of the approach (drive)
     *
     * @return self
     */
    public function setDurationApproach($durationApproach)
    {
        $this->container['durationApproach'] = $durationApproach;

        return $this;
    }

    /**
     * Gets durationDeparture
     *
     * @return int|null
     */
    public function getDurationDeparture()
    {
        return $this->container['durationDeparture'];
    }

    /**
     * Sets durationDeparture
     *
     * @param int|null $durationDeparture duration (in minutes) of the departure (drive)
     *
     * @return self
     */
    public function setDurationDeparture($durationDeparture)
    {
        $this->container['durationDeparture'] = $durationDeparture;

        return $this;
    }

    /**
     * Gets startBreak
     *
     * @return int|null
     */
    public function getStartBreak()
    {
        return $this->container['startBreak'];
    }

    /**
     * Sets startBreak
     *
     * @param int|null $startBreak timestamp when the pause starts (0 if no pause is given)
     *
     * @return self
     */
    public function setStartBreak($startBreak)
    {
        $this->container['startBreak'] = $startBreak;

        return $this;
    }

    /**
     * Gets durationBreak
     *
     * @return int|null
     */
    public function getDurationBreak()
    {
        return $this->container['durationBreak'];
    }

    /**
     * Sets durationBreak
     *
     * @param int|null $durationBreak duration of the pause (in minutes)
     *
     * @return self
     */
    public function setDurationBreak($durationBreak)
    {
        $this->container['durationBreak'] = $durationBreak;

        return $this;
    }

    /**
     * Gets erpNumber
     *
     * @return string|null
     */
    public function getErpNumber()
    {
        return $this->container['erpNumber'];
    }

    /**
     * Sets erpNumber
     *
     * @param string|null $erpNumber if the support has an erp number entered
     *
     * @return self
     */
    public function setErpNumber($erpNumber)
    {
        $this->container['erpNumber'] = $erpNumber;

        return $this;
    }

    /**
     * Gets extern
     *
     * @return bool|null
     */
    public function getExtern()
    {
        return $this->container['extern'];
    }

    /**
     * Sets extern
     *
     * @param bool|null $extern if this support was created by a customer login, this value is \"true\"
     *
     * @return self
     */
    public function setExtern($extern)
    {
        $this->container['extern'] = $extern;

        return $this;
    }

    /**
     * Gets externalTicketId
     *
     * @return string|null
     */
    public function getExternalTicketId()
    {
        return $this->container['externalTicketId'];
    }

    /**
     * Sets externalTicketId
     *
     * @param string|null $externalTicketId if the support has an external ticket number entered, this number is given here
     *
     * @return self
     */
    public function setExternalTicketId($externalTicketId)
    {
        $this->container['externalTicketId'] = $externalTicketId;

        return $this;
    }

    /**
     * Gets hourlyRate
     *
     * @return double|null
     */
    public function getHourlyRate()
    {
        return $this->container['hourlyRate'];
    }

    /**
     * Sets hourlyRate
     *
     * @param double|null $hourlyRate the hourly rate for this support (or the rate per working unit)
     *
     * @return self
     */
    public function setHourlyRate($hourlyRate)
    {
        $this->container['hourlyRate'] = $hourlyRate;

        return $this;
    }

    /**
     * Gets installationFee
     *
     * @return bool|null
     */
    public function getInstallationFee()
    {
        return $this->container['installationFee'];
    }

    /**
     * Sets installationFee
     *
     * @param bool|null $installationFee wether the support will be billed as an \"installation fee\" with a fixed price
     *
     * @return self
     */
    public function setInstallationFee($installationFee)
    {
        $this->container['installationFee'] = $installationFee;

        return $this;
    }

    /**
     * Gets installationFeeAmount
     *
     * @return double|null
     */
    public function getInstallationFeeAmount()
    {
        return $this->container['installationFeeAmount'];
    }

    /**
     * Sets installationFeeAmount
     *
     * @param double|null $installationFeeAmount if the support will be billed as an \"installation fee\", the amount is given here
     *
     * @return self
     */
    public function setInstallationFeeAmount($installationFeeAmount)
    {
        $this->container['installationFeeAmount'] = $installationFeeAmount;

        return $this;
    }

    /**
     * Gets installationFeeTypeId
     *
     * @return int|null
     */
    public function getInstallationFeeTypeId()
    {
        return $this->container['installationFeeTypeId'];
    }

    /**
     * Sets installationFeeTypeId
     *
     * @param int|null $installationFeeTypeId if the support will be billed as an \"installation fee\", the id of the installation fee type is given here
     *
     * @return self
     */
    public function setInstallationFeeTypeId($installationFeeTypeId)
    {
        $this->container['installationFeeTypeId'] = $installationFeeTypeId;

        return $this;
    }

    /**
     * Gets internal
     *
     * @return bool|null
     */
    public function getInternal()
    {
        return $this->container['internal'];
    }

    /**
     * Sets internal
     *
     * @param bool|null $internal if this support is marked as \"internal\" (customers won't see those)
     *
     * @return self
     */
    public function setInternal($internal)
    {
        $this->container['internal'] = $internal;

        return $this;
    }

    /**
     * Gets outlook
     *
     * @return bool|null
     */
    public function getOutlook()
    {
        return $this->container['outlook'];
    }

    /**
     * Sets outlook
     *
     * @param bool|null $outlook true, if this support is a TANSS2Ex appointment
     *
     * @return self
     */
    public function setOutlook($outlook)
    {
        $this->container['outlook'] = $outlook;

        return $this;
    }

    /**
     * Gets supportIconType
     *
     * @return string|null
     */
    public function getSupportIconType()
    {
        return $this->container['supportIconType'];
    }

    /**
     * Sets supportIconType
     *
     * @param string|null $supportIconType determines the icon used to display this support
     *
     * @return self
     */
    public function setSupportIconType($supportIconType)
    {
        $allowedValues = $this->getSupportIconTypeAllowableValues();
        if (!is_null($supportIconType) && !in_array($supportIconType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'supportIconType', must be one of '%s'",
                    $supportIconType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['supportIconType'] = $supportIconType;

        return $this;
    }

    /**
     * Gets textIntern
     *
     * @return string|null
     */
    public function getTextIntern()
    {
        return $this->container['textIntern'];
    }

    /**
     * Sets textIntern
     *
     * @param string|null $textIntern internal remarks for this support (customers won't see this)
     *
     * @return self
     */
    public function setTextIntern($textIntern)
    {
        $this->container['textIntern'] = $textIntern;

        return $this;
    }

    /**
     * Gets voucherId
     *
     * @return int|null
     */
    public function getVoucherId()
    {
        return $this->container['voucherId'];
    }

    /**
     * Sets voucherId
     *
     * @param int|null $voucherId if the support was already booked and assigned to a voucher, the voucher id is given here
     *
     * @return self
     */
    public function setVoucherId($voucherId)
    {
        $this->container['voucherId'] = $voucherId;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


